
# common definition for Makefile
# for GNU c++
CCACHE=$(shell eval ls /usr/local/bin/ccache 2>/dev/null)

CXX = $(CCACHE) g++ -x c++
CC = $(CCACHE) gcc
LD = g++
CP = cp -f
AR = ar r
MKDIR=mkdir -p
RM=rm -f
CFLAGS = -O3 -c -fomit-frame-pointer -D_FILE_OFFSET_BITS=64 -DNDEBUG
CFLAGS_WARN=-Wall -W -Wformat=2 -Wcast-qual -Wcast-align -Wwrite-strings -Wconversion -Wfloat-equal -Wpointer-arith #-Wswitch-enum -Wstrict-aliasing=2 
CFLAGS+=$(CFLAGS_WARN)
#CFLAGS = -Wall -g -c -D_FILE_OFFSET_BITS=64
LDFLAGS = -s -lm -linclude.mie -L../include.mie/
AS = nasm
AFLAGS = -f elf -D__unix__ -i./x86/ -i../include.mie/x86/

