#include "../mie_common.h"
#include "../mie_file.h"

static const char s_oneMB[1024 * 1024] = {};

int main(int argc, char *argv[])
{
	int fileSize = 0;
	const char *fileName = 0;

	argc--, argv++;
	while (argc > 0) {
		if (argc > 1 && strcmp(*argv, "-s") == 0) {
			argc--, argv++;
			fileSize = atoi(*argv);
		} else
		{
			fileName = *argv;
		}
		argc--, argv++;
	}
	printf("fileName=%s, fileSize=%dMB\n", fileName, fileSize);
	MIE::File out;
	if (!out.openW(fileName)) {
		fprintf(stderr, "can't open[%s]\n", fileName);
		return 1;
	}

	for (int i = 0; i < fileSize; i++) {
		out.write(s_oneMB, sizeof(s_oneMB));
	}
	return 0;
}

