/**
	XbheXg
*/
#include <stdio.h>
#include "../mie_thread.h"

const int N = 10;
int s_count = 0;

class ThreadTest : public MIE::ThreadBase {
	enum State {
		SLEEP, //!< ҋ@
		ACTIVE, //!< t@CXV
		DEAD //!< Xbh
	} state_;

	MIE::CriticalSection& cs_;
public:
	ThreadTest(MIE::CriticalSection& cs)
		: cs_(cs)
	{
	}

	// XbhJnGg|Cg
	void threadEntry()
	{
		puts("start threadEntry");
		for (int i = 0; i < N; i++) {
			int a;
			MIE::AutoLock al(cs_);
			a = s_count;
			sleepMsec(10);
			s_count = a + 1;
		}
		puts("wait threadEntry");
		for (;;) {
			sleepMsec(1000);
		}
	}

	/**
		Xbh̒~
	*/
	void stopThread()
	{
		state_ = DEAD;
	}
};

int main()
{
	MIE::CriticalSection cs_;
	ThreadTest test(cs_);
	test.beginThread();

	int i;
	/*
		mainƕʃXbhłꂼs_countNCNg
		v2NɂȂĂ邩ǂ`FbN
	*/
	puts("check cs");
	puts("start main");
	for (i = 0; i < N; i++) {
		int a;
		MIE::AutoLock al(cs_);
		a = s_count;
		test.sleepMsec(10);
		s_count = a + 1;
	}
	puts("end main");

	for (i = 0; i < 5; i++) {
		test.sleepMsec(500);
	}
	printf("s_count=%d(%s)\n", s_count, (s_count == N * 2) ? "OK" : "NG");
	return 0;
}
