#ifndef EDITBOX_CTL_H_
#define EDITBOX_CTL_H_
/*!
	@file editbox_ctl.h
	@brief GfBbg{bNXRg[
	@author $Author: shigeo $
	@version $Revision: 1.3 $
	@date $Date: 2006/05/19 01:54:49 $
*/

#include "windowhandle.h"

namespace MIE {

class EditBoxCtl : public WindowHandle {
	int id_;
	void (*handler_)(int state, void *arg);
	void *arg_;
public:
	enum {
		MAX_STR_SIZE = 256
	};
	/*!
		RXgN^
	*/
	EditBoxCtl()
		: id_(0)
	{
	}

	int onCommand(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		if (LOWORD(wParam) == id_) {
			if (HIWORD(wParam) == EN_UPDATE) {
				char buf[MAX_STR_SIZE];
				GetWindowText(hWnd_, buf, sizeof(buf));
				if (handler_) handler_(reinterpret_cast<int>(buf), arg_);
				return TRUE;
			}
		}
		return FALSE;
	}
	/*!
		GfBbg{bNXRg[
		@param parent [in] enh
		@param id [in] {^ʎq
		@param str [in] ̕
		@param handler [in] ύXƂɌĂ΂nh(stateɃ{^̏Ԃ)
		@param arg [in] nhɓn郆[U`|C^
	*/
	bool create(HWND parent, int id, const char *str,
		void (*handler)(int state, void *arg) = 0,
		void *arg = 0)
	{
		// EBhEnh擾
		hWnd_ = GetDlgItem(parent, id);
		if (hWnd_ == 0) return false;
		handler_ = handler;
		arg_ = arg;
		id_ = id;

		setText(str);
		return true;
	}
};

} // end of namespace

#endif /* EDITBOX_CTL_H_ */
