//
//
// ֐ : CreateRgnFromBmp ( HBITMAP, COLORREF )
//
// pr : rbg}bv烊[W쐬
//
//  :
//      hBitmap - [W쐬rbg}bv
//      cTransparentColor - F(RGB(255,255,255)̂悤Ɏw肷)
//                          ftHgł͍̃hbg̐FFƂȂ
//
//

HRGN CreateRgnFromBmp(HBITMAP hBitmap, COLORREF cTransparentColor  = 0xffffffff)
{
    BITMAP bm;                  // BITMAP structure
    HBITMAP hDIBSection = NULL; // Handle to DIB
    COLORREF* pBits = NULL;    // Pointer to the DIB's bit values
    HRGN hRgn = NULL;          // Handle to Region

    // hBitmap ̃`FbN
    if (!hBitmap)
        return NULL;

    // cTransparentColor̃oCgI[_[ϊ
    // ( COLORREF=0x00bbggrr  COLORREF=0xrrggbb ւƕϊ )
    // NOTE:
    //  CORORREF̃f[^32rbg^ 0x00bbggrr ƂȂĂ̂ɑ΂A
    //  32rbgBMP̏ꍇAt@C\ bbggrr00 ƂȂĂB
    //  IntelЂ̃}CNvZbT̓gGfBA(little endian)
    //  Ȃ̂ŁA bbggrr00 ƔzuĂA32rbglł
    //  0x00rrggbb ƂȂB
    cTransparentColor = (cTransparentColor & 0xff00ff00) |
                        (cTransparentColor & 0x00ff0000) >> 16 |
                        (cTransparentColor & 0x000000ff) << 16;

    // rbg}bṽTCY擾
    if (!GetObject(hBitmap, sizeof(bm), &bm))
        return NULL;

    // BLOCK : DIB̍쐬
    //         hDIBSection Ƀrbg}bvnhApBits Ƀrbgւ
    //        |C^ݒ肳B(DeleteObject(hDIBSection); YĂ͂Ȃ)
    //        s hDIBSection y pBits  NULL ̂܂܁B
    {
        HDC hMemDC = NULL;          // Handle to a device context : DIB
        HDC hCopyDC = NULL;        // Handle to a device context : DDB -> DIB
        HBITMAP hOldDIBsBmp = NULL; // Handle of the object being replaced : DIB
        HBITMAP hOldDDBsBmp = NULL; // Handle of the object being replaced : DDB
        BITMAPINFOHEADER bmih;      // DIB's BITMAPINFOHEADER structure
        BOOL bResultBitBlt = TRUE;  // Result of BitBlt function

        // foCXReLXg쐬
        hMemDC = CreateCompatibleDC(NULL);
        if (!hMemDC)
            goto cleanupdib;
        // DIB(Device Independent Bitmaps : foCXɈˑȂrbg}bv)
        // ̃wb_
        bmih.biSize            = sizeof(BITMAPINFOHEADER), // size of the structure
        bmih.biWidth            = bm.bmWidth;  // width of the bitmap
        bmih.biHeight          = bm.bmHeight;  // height of the bitmap
        bmih.biPlanes          = 1;        // must be set to 1
        bmih.biBitCount        = 32;      // maximum of 2^32 colors
        bmih.biCompression      = BI_RGB;  // an uncompressed format
        bmih.biSizeImage        = 0;        // must be set to zero for BI_RGB bitmaps
        bmih.biXPelsPerMeter    = 0;        // set to zero
        bmih.biYPelsPerMeter    = 0;        // set to zero
        bmih.biClrUsed          = 0;        // must be set to zero
        bmih.biClrImportant    = 0;        // set to zero, all colors are required
        // DIB̍쐬
        hDIBSection = CreateDIBSection(
            hMemDC,            // HDC hdc : handle to device context
            (CONST BITMAPINFO*)&bmih,  // CONST BITMAPINFO *pbmi : pointer to BITMAPINFO structure
            DIB_RGB_COLORS, // UINT iUsage : color data type(RGB values)
            (void**)&pBits, // VOID *ppvBits : pointer to receive the bitmap's bit values
            NULL,          // HANDLE hSection : handle to a file mapping object.
                            //                  This parameter can be NULL.
            0);            // DWORD dwOffset : ignored by hSection
        if (!hDIBSection)
            goto cleanupdib;

        // 쐬DIBDCɑI
        hOldDIBsBmp = (HBITMAP)SelectObject(hMemDC, hDIBSection);
        // 摜̓]ƂȂ郁foCXReLXg쐬
        hCopyDC = CreateCompatibleDC(hMemDC);
        if (!hCopyDC)
            goto cleanupdib;

        // hBitmap Ŏw肳ꂽrbg}bvfoCXReLXgɑI
        hOldDDBsBmp = (HBITMAP)SelectObject(hCopyDC, hBitmap);

        // rbg}bvhMemDCɓ]
        bResultBitBlt = BitBlt(hMemDC, 0, 0, bm.bmWidth, bm.bmHeight, hCopyDC, 0, 0, SRCCOPY);

        // N[Abv
        cleanupdib:
        if (hOldDDBsBmp)    SelectObject(hCopyDC, hOldDDBsBmp);
        if (hCopyDC)        DeleteDC(hCopyDC);
        if (hOldDIBsBmp)    SelectObject(hMemDC, hOldDIBsBmp);
        if (hMemDC)        DeleteDC(hMemDC);

        // BitBlt ֐sĂDIB폜NULLɐݒ
        if (!bResultBitBlt)
        {
            DeleteObject(hDIBSection);
            hDIBSection = NULL;
            pBits = NULL;
        }
    }  // End of BLOCK : DIB̍쐬

    // DIB̍쐬ɎsĂ烊[W͍Ȃ
    if (!hDIBSection)
        return NULL;

    // BLOCK : [W̍쐬
    //        ExtCreateRegion()͏ォ牺AEփ\[gĂ
    //        f[^nȂ΁AxȂ
    {
        int xx;            // x ̒lۑ

        // maxRects  Pȏ 2000 łȂĂ͂ȂȂ
        // ȂȂWindows9xłExtCreateRegion()͎lp`̐
        // s邩łB(InternetExplorerCXg[
        // Ă4000ővłB)
        DWORD maxRects = 200;

        // AP[g
        HANDLE hData = GlobalAlloc(GMEM_MOVEABLE, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects));
        if (!hData)
            return NULL;

        // O[oIuWFNgbNAubN̐擪ւ̃|C^擾
        RGNDATA *pRgnData = (RGNDATA *)GlobalLock(hData);
        if (!pRgnData)
        {
            // bNsAP[gJ
            GlobalFree(hData);
            // N[Abv
            DeleteObject(hDIBSection);
            return NULL;
        }

        // RGNDATA\̂̃o
        pRgnData->rdh.dwSize = sizeof(RGNDATAHEADER);
        pRgnData->rdh.iType = RDH_RECTANGLES;
        pRgnData->rdh.nCount = pRgnData->rdh.nRgnSize = 0;
        SetRect(&pRgnData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);

        // Fw肳ĂȂ΁Ãhbg̐FFƂȂ
        if (cTransparentColor == 0xffffffff)
            cTransparentColor = *pBits;

        // rbg}bv̍wĂ|C^̃|C^ɐݒ
        pBits += (bm.bmHeight - 1) * bm.bmWidth;

        // cɃrbgF𒲂ׁAFŖ[Wɒǉ
        for (int y = 0; y < bm.bmHeight; y++)  // c
        {
            for (int x = 0; x < bm.bmWidth; x++)    // 
            {
                if (*pBits != cTransparentColor)    // Fł͂ȂH
                {                                  // Yes!
                    xx = x;    // x ۑ(Fł͂Ȃ_̎n܂ۑ)

                    // AFł͂Ȃ̈߂
                    for (x = x + 1; x < bm.bmWidth; x++)
                    {
                        // |C^CNg
                        pBits++;

                        // FɂȂ break
                        if (*pBits == cTransparentColor)
                            break;
                    }

                    // RGNDATAɋ߂̈ǉ
                    RECT *pr = (RECT *)pRgnData->Buffer;
                    SetRect(&pr[pRgnData->rdh.nCount], xx, y, x, y+1);

                    // [W͂ލŏ̗̈ݒ
                    if (xx < pRgnData->rdh.rcBound.left)
                        pRgnData->rdh.rcBound.left = xx;
                    if (y < pRgnData->rdh.rcBound.top)
                        pRgnData->rdh.rcBound.top = y;
                    if (x > pRgnData->rdh.rcBound.right)
                        pRgnData->rdh.rcBound.right = x;
                    if (y+1 > pRgnData->rdh.rcBound.bottom)
                        pRgnData->rdh.rcBound.bottom = y+1;

                    // f[^CNg
                    pRgnData->rdh.nCount++;

                    // [Wf[^̐mۂ𒴂悤Ƃ
                    // Ax[W쐬Ă܂B
                    if (maxRects <= pRgnData->rdh.nCount)
                    {
                        HRGN hRgnTmp = ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), pRgnData);
                        if (!hRgnTmp)
                        {
                            // hRgn쐬Ăꍇ͊J
                            if (hRgn)
                                DeleteObject(hRgn);
                            // mۂJ
                            GlobalUnlock(hData);
                            GlobalFree(hData);
                            // N[Abv
                            DeleteObject(hDIBSection);

                            return NULL;
                        }

                        // łɃ[W쐬Ăꍇ́Aɑ݂郊[W
                        // Ƃ̂nqƂB
                        // ȊO͍쐬[WhRgnƂB
                        if (hRgn)
                        {
                            CombineRgn(hRgn, hRgn, hRgnTmp, RGN_OR);
                            DeleteObject(hRgnTmp);
                        }
                        else
                            hRgn = hRgnTmp;

                        pRgnData->rdh.nCount = 0;
                        SetRect(&pRgnData->rdh.rcBound, MAXLONG, MAXLONG, 0, 0);
                    }
                }
                // |C^CNg
                pBits ++;
            }
            // |C^摜̂PCō[w悤ɐݒ
            pBits -= 2 * bm.bmWidth;
        }

        // [W쐬
        HRGN hRgnTmp = ExtCreateRegion(NULL, sizeof(RGNDATAHEADER) + (sizeof(RECT) * maxRects), pRgnData);
        if (!hRgnTmp)
        {
            // [W̍쐬ɎsꍇAɍ쐬[W폜
            if (hRgn)
                DeleteObject(hRgn);
        }
        else
        {
            // łɃ[W쐬Ăꍇ́Aɑ݂郊[W
            // Ƃ̂nqƂB
            // ȊO͍쐬[WhRgnƂB
            if (hRgn)
            {
                CombineRgn(hRgn, hRgn, hRgnTmp, RGN_OR);
                DeleteObject(hRgnTmp);
            }
            else
                hRgn = hRgnTmp;
        }

        // mۂJ
        GlobalUnlock(hData);
        GlobalFree(hData);

    }  // End of BLOCK : [W̍쐬

    // N[Abv
    DeleteObject(hDIBSection);

    // return the handle of the region
    return hRgn;
}
