/*!
	^CJvZÍT[o
*/

#define STRICT
#define _WIN32_WINNT 0x0500
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "user32.lib")
#pragma comment(lib, "comdlg32.lib")
#pragma comment(lib, "shell32.lib")
#pragma comment(lib, "gdi32.lib")
#include "basedialog.h"
#include "about_dlg.h"
#include "server_resource.h"


#include "mie_timecapsule.h"
#include "mie_thread.h"
#include "clockstring.h"
#include "ts_server.h"
#include "ts_common.h"

class DialogMain : public MIE::ThreadBase, public MIE::BaseDialog {
public:
	DialogMain(int argc, char *argv[])
		: argc_(argc)
		, argv_(argv)
	{
	}
private:
	ClockString clock_;
	MIE_TC::TSserver system;
	AboutDlg aboutDlg_;
	int argc_;
	char **argv_;
	HINSTANCE hInst_;
	HBITMAP hBitmap_;
	BITMAP bitmap_;
	HDC hMemDc_;

	void threadEntry()
	{
		if (system.run(argc_ + 1, argv_ + 1)) {
			MessageBox(NULL, "ERROR", "", MB_OK);
			exit(1);
		}
	}

	void stopThread()
	{
	}
	/*
		WM_INITDIALOGnh
		
	*/
	void onInitDialog(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{

		// 
		clock_.setHandle(GetDlgItem(hWnd, IDC_TIMER));
		aboutDlg_.create(hWnd, IDD_ABOUT_DLG);

		RECT rect;
		GetClientRect(hWnd, &rect);
		onSize(hWnd, SIZE_RESTORED, rect.right | (rect.bottom << 16));
		beVisible();

		// 荞݃nh
		SetTimer(hWnd, IDC_TIMER, 1000 /* msec */, NULL);

		/*
			ȂƂȂ
		*/
#if 0
		if(0){
		//
//			HWND hWnd = GetDlgItem(aboutDlg_.getHandle(), IDB_BIG_TOKEI);
			HWND hWnd = aboutDlg_.getHandle();
		SetWindowLong(hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) | WS_EX_LAYERED);
		SetLayeredWindowAttributes(hWnd, 0x00C0C0C0, (255 * 70) / 100, LWA_COLORKEY);//LWA_ALPHA);

hWnd = GetDlgItem(aboutDlg_.getHandle(), IDB_BIG_TOKEI);
		SetWindowLong(hWnd, GWL_EXSTYLE, GetWindowLong(hWnd, GWL_EXSTYLE) | WS_EX_LAYERED);
		SetLayeredWindowAttributes(hWnd, 0x00FFFFFF, (255 * 70) / 100, LWA_COLORKEY);//LWA_ALPHA);


//		SetLayeredWindowAttributes(hWnd, 0, (255 * 70) / 100, LWA_ALPHA);
		SetLayeredWindowAttributes(hWnd, 0x00FFFFFF, (255 * 70) / 100, LWA_COLORKEY);//LWA_ALPHA);
		}
#endif
//////////////////////////////////
{
	// CX^X̎̂͌ďovZX̐擪AhX
	hInst_ = (HINSTANCE)GetModuleHandle(0);

#if 0
	hBitmap_ = (HBITMAP)LoadBitmap(hInst_, MAKEINTRESOURCE(IDB_BIG_TOKEI));

//	hMemDc_ = CreateCompatibleDC(0);
//	SelectObject(hMemDc_, hBitmap_);
//	GetObject(hBitmap_, sizeof(BITMAP), &bitmap_);

	// rbg}bv烊[W쐬

	HRGN hRgn = CreateRgnFromBmp(hBitmap_);

	// rbg}bv폜
//	DeleteObject(hBitmap_);

	SetWindowRgn(hWnd_, hRgn, TRUE);


//	SetProp(hWnd_, "region", hRgn);

#endif
//	DeleteObject(hRgn);
}
//////////////////////////////////

		beginThread();
	}

	/*
		WM_TIMERnh
	*/
	void onTimer(HWND , WPARAM , LPARAM)
	{
		clock_.updateTime();
	}

	/*
		WM_SIZEnh
	*/
	void onSize(HWND hWnd, WPARAM wParam, LPARAM lParam)
	{
		int width = LOWORD(lParam);
		int height = HIWORD(lParam);
		clock_.resize(width, height);
	}

	/*!
		EBhEvV[W
	*/
	LRESULT wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
		switch (msg) {
		case WM_INITDIALOG:
			onInitDialog(hWnd, wParam, lParam);
			return TRUE;

		case WM_TIMER:
			onTimer(hWnd, wParam, lParam);
			return TRUE;


		case WM_SIZE:
			onSize(hWnd, wParam, lParam);
			return TRUE;
#if 0
		case WM_PAINT:
			{
				PAINTSTRUCT ps;
				HDC hdc = BeginPaint(hWnd, &ps);
//				vram_.onPaint(hdc);
				BitBlt(hdc, 0, 0, bitmap_.bmWidth, bitmap_.bmHeight, hMemDc_, 0, 0, SRCCOPY);
				
				EndPaint(hWnd, &ps);
			}
			return TRUE;
#endif

//////////////
//		case WM_NCRBUTTONDOWN:
		case WM_RBUTTONDOWN:
			{
				int xPos, yPos;
				HMENU hMenu, hSubMenu;

			POINT pt;
			GetCursorPos(&pt);

				xPos = LOWORD(lParam);
				yPos = HIWORD(lParam);

				hMenu = LoadMenu(hInst_, MAKEINTRESOURCE(IDR_MENU_SERVER));
				hSubMenu = GetSubMenu(hMenu, 0);

//				TrackPopupMenu(hSubMenu, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON, xPos, yPos, 0, hWnd, NULL);
				TrackPopupMenu(hSubMenu, TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, 0, hWnd, NULL);
				break;
			}
#if 0
		case WM_NCHITTEST:
			{
				// ^Cgo[Ƀ}EX悤Windowsx
				wParam = DefWindowProc(hWnd, msg, wParam, lParam);
				if (wParam == HTCLIENT) return HTCAPTION;
				return wParam;
			}
#endif
/////////////////////////

		case WM_CLOSE:
			PostQuitMessage(0);
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam)) {

			case IDC_ABOUT_DLG:
				aboutDlg_.beVisible();
				return TRUE;

			case IDCANCEL:
			case ID_EXIT:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				return TRUE;
			default:
				break;
			}
			break;

		default:
			break;
		}
		return FALSE;
	}
};

class TSserverApp {
public:
	TSserverApp()
	{
		InitCommonControls();
	}

	void run(int argc, char *argv[])
	{
		DialogMain dlgMain(argc, argv);
		dlgMain.create(NULL, IDD_SERVER);

		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0) > 0) {
			if (!dlgMain.processIfDialogMessage(&msg)) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
};

int appmain(int argc, char *argv[])
{
	MIE_TC::init();

	if (argc == 1) {
		MessageBox(NULL, "-init random-stringw肵Ă", ERROR, MB_OK | MB_ICONWARNING);
		return 0;
	}
	TSserverApp app;
	app.run(argc, argv);
	return 0;
}

#if 0// consolet
int main(int argc, char *argv[])
{
	return appmain(argc, argv);
}
#else
int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	return appmain(__argc, __argv);
}
#endif
