
/*!
	^CJvZÍeXgvO
*/

#define CHECK_MEMORY_LEAK
#if defined(_MSC_VER) && defined(CHECK_MEMORY_LEAK) && !defined(NDEBUG)
	#define _CRTDBG_MAP_ALLOC   /* for malloc_malloc_dbg̒u */
	#include <windows.h>
	#include <crtdbg.h> // for _CrtDumpMemoryLeaks
	static void MIE_MEM_Init()
	{
		_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
		_CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_FILE);
		_CrtSetReportFile(_CRT_WARN, _CRTDBG_FILE_STDOUT);
		_CrtSetReportMode(_CRT_ERROR, _CRTDBG_MODE_FILE);
		_CrtSetReportFile(_CRT_ERROR, _CRTDBG_FILE_STDOUT);
		_CrtSetReportMode(_CRT_ASSERT, _CRTDBG_MODE_FILE);
		_CrtSetReportFile(_CRT_ASSERT, _CRTDBG_FILE_STDOUT);
	}
#else
	#define MIE_MEM_Init()
#endif
#include <stdio.h>
#include <string.h>
#include <string>
#include "mie_timecapsule.h"

using namespace MIE_TC;

int main()
{
	MIE_MEM_Init();
	const char *publicKeyName = "testkey.txt"; /* Jt@C */
	const char *decTime = "20060522115934"; /* 2006/5/22 11:59:34 */

	////////////////////////////////////////////////////////////////////
	/*
		VXe(KxĂяo)
	*/
	puts("SYSTEM");
	puts("initialize system");
	init();

	////////////////////////////////////////////////////////////////////
	/*
		tF[Y(ʃAvł͕sv)
		閧ƌJ쐬
	*/

	SignedTimeInfo signedTimeInfo; /*  */

	puts("TIME SERVER");
	{
		PrivateKey privateKey; /* 閧 */
		PublicKey publicKey; /* J */

		/* seedɔ閧ƌJ쐬 */
		puts("create public key and private key");
		privateKey.init("123456783095873yt98375yt3759", &publicKey);
		printf("public key=\n[%s]\n", publicKey.get());

		/* Jۑ */
		printf("save %s\n", publicKeyName);
		publicKey.save(publicKeyName);

		/*
			w
			{͖bŝׂł͈xĂ
		*/
		TimeInfo timeInfo;
		timeInfo.set(decTime);

		/*  */
		puts("sign time");
		privateKey.sign(&signedTimeInfo, timeInfo, publicKey);
	}

	////////////////////////////////////////////////////////////////////
	/*
		ÍtF[Y
	*/

	/*
		{sessionKey1͈ÍtF[Ył̂ݕKvȏł邪C
		ʂ̌؂̂ߎcĂ
	*/
	SessionKey sessionKey1;

	std::string header; /* ÍꂽZbVۑobt@(wb_) */

	puts("ENCODER");
	{
		/* Jǂݍ */
		puts("load public key");
		PublicKey publicKey;
		publicKey.load(publicKeyName);

		/* w */
		TimeInfo timeInfo;
		timeInfo.set(decTime);

		/* ƌJɃZbVƈÍꂽZbV쐬 */
		EncodedSessionKey encodedSessionKey;
		puts("create session key and encoded session key from time and public key");
		sessionKey1.init(&encodedSessionKey, publicKey, timeInfo, "51295461298574162985712");

		/*
			̃ZbVAESȂǂŃRecÍ
		*/
		printf("session key by generator=\n[%s]\n", sessionKey1.get());
		/*
			ÍꂽZbV̓Rec̃wb_Ƃėp
			ł͒PɕɂĂ
		*/
		printf("header=\n[%s]\n", encodedSessionKey.get());
		header = encodedSessionKey.get();
	}

	////////////////////////////////////////////////////////////////////
	/*
		tF[Y
		ÍꂽZbVƏƂɕ
	*/

	puts("DECODER");
	{
		SessionKey sessionKey2;

		/* Ă񂩂ÍꂽZbV𕜌 */
		puts("receive encoded session key");
		EncodedSessionKey encodedSessionKey;
		encodedSessionKey.set(header.c_str());

		/*  */
		puts("decode sesison key from encoded session key and signed time");
		encodedSessionKey.decode(&sessionKey2, signedTimeInfo);

		printf("session key by user=\n[%s]\n", sessionKey2.get());

		/*
			ÍtF[YŐZbVƈv邱ƂmF
		*/
		puts("comare key");
		if (strcmp(sessionKey1.get(), sessionKey2.get()) == 0) {
			puts("OK : key is same.");
		} else {
			puts("NG : key is different.");
		}
	}
	return 0;
}
