#include "../base/common.h"
#include "../base/implementation.h"
#include "mtt_imp.h"

//#ifndef NDEBUG
//#include <locale>
//#endif
#include <clocale>
#include <iostream>

namespace MTT {

template<>
void ModP::init()
{
	factor_m_.fromField(ModP(TEXT_PARAM_M).p_value_);
	factor_co_m_.fromField(ModP(TEXT_PARAM_CO_M).p_value_);
	sqrtexp_.fromField(ModP(TEXT_SQRTEP).p_value_);
}

void InitSystem()
{
	/* for VC2005 */
#if 0
	static char coutBuf[4096];
	typedef std::codecvt<wchar_t,char,std::mbstate_t> cvt_type;
	std::locale loc("");
	const cvt_type& cvt = std::use_facet<cvt_type>(loc);

	assert(cvt.max_length() < sizeof(coutBuf));
	std::cout.rdbuf()->pubsetbuf(coutBuf, sizeof(coutBuf));
#endif
	std::cout.rdbuf()->pubsetbuf(0, 4096);

	/* ofstream̂ */
	std::setlocale(LC_ALL, "");
	/* --- */

	MttBitsBase::setup();
	MttFpBase::setup();
	MttFmBase::setup();

	ModP::init();
}

} // end of namespace
