#ifndef   MTT_TYPES_TMPL_H
#define   MTT_TYPES_TMPL_H

// ===========================================================================
//  types_tmpl.h -- ^̒`
// ---------------------------------------------------------------------------
// gp̐ 
//  L(F_qyF_m)Aȉ~ȐAyAOȂǂ̌vZsȂۂ̌^ɂ͂
// t@C#includeΗǂB field_f?_tmpl.h/elliptic_tmpl.h ͎I
// #includeB
//  ModP, ModMꂼmodulo p, mł̑{ZNXƂƂAȉ̂悤
// ȃNXvZɕKvȃNXƂȂF
//	Mtt<ModP>::Fq      --  LF_q
//	Mtt<ModM>::Fm      --  LF_m
//	Mtt<ModP>::ECurve  --  ȉ~Ȑ
//	Mtt<ModP>::EPoint  --  ȉ~Ȑ̓_
// ܂AF_qׂ̌̂F_p̌̕Aȉ~Ȑ̓_k{߂
// ɂ́Aȉ̃NXpF
//	MttPower<ModP, ModM>::Fq      -- LF_q (F_p)̌
//	MttPower<ModP, ModM>::ECurve  -- ȉ~Ȑ̓_

#include "field_fq_tmpl.h"
#include "elliptic_tmpl.h"
#include "field_fm_tmpl.h"
#include "bitwindow_tmpl.h"
namespace mttfq { template<class Mp, class Mm> class power_; }
namespace mttec { template<class Mp, class Mm> class power_; }

template <class Mod>
struct Mtt {
	typedef class mttfq::e_<Mod, Mod> Fq;
	typedef class mttfq::e_<Mod, Mod> Fp;
	typedef class mttfm::e_<Mod, Mod> Fm;
	typedef class mttec::ec_<Fq> ECurve;
	typedef struct mttec::ep_<Fq> EPoint;
};

template <class Mp, class Mm>
struct MttPower {
	typedef class mttfq::power_<
		typename Mtt<Mp>::Fp, typename Mtt<Mm>::Fm> Fq;
	typedef class mttec::power_<
		typename Mtt<Mp>::Fp, typename Mtt<Mm>::Fm> ECurve;
};

template <class Bits>
struct MttWindow {
	typedef class mttbw::b_<Bits> Exponent;
	typedef class mttbw::signed57_<Bits> Signed57;
	typedef class mttbw::unsigned5_<Bits> Unsigned5;
};



#endif /* MTT_TYPES_TMPL_H */
