/*!
	@brief RijndaeleXg
	@file $RCSfile: cmd.cpp,v $
	@version $Revision: 1.2 $
	@date $Date: 2007/08/24 02:33:46 $
*/
#include <stdio.h>
#include <stdlib.h>
#include "cipher_rijndael.h"
#include <fstream>

void update(void *, int doneSize)
{
	static int totalDoneSize = 0;
	totalDoneSize += doneSize;
//	printf("doneSize=%d\r", totalDoneSize);
}

/*!
	Tv
	R}hC̃IvV
	-(e|d) ̓t@C o̓t@C  
	-e : GR[h
	-d : fR[h
	 128/192/256
*/
int main(int argc, char *argv[])
{
	CipherRijndael::MODE mode;
	std::ifstream ifs;
	std::ofstream ofs;

	if (argc < 6) {
USAGE:
		fprintf(stderr, "%s -(e|d) input-file output-file key-string key-len\n", argv[0]);
		return 1;
	}
	if (argv[1][0] == '-') {
		switch (argv[1][1]) {
		case 'e':
			mode = CipherRijndael::ENCODING;
			break;
		case 'd':
			mode = CipherRijndael::DECODING;
			break;
		default:
			goto USAGE;
		}
	} else {
		goto USAGE;
	}

	ifs.open(argv[2], std::ios::binary);
	if (!ifs) {
		fprintf(stderr, "can't open [%s]\n", argv[2]);
		return 1;
	}
	ofs.open(argv[3], std::ios::binary);
	if (!ofs) {
		fprintf(stderr, "can't open [%s]\n", argv[3]);
		return 1;
	}
	RIJNDAEL_do(mode, argv[4], atoi(argv[5]), ifs, ofs, update);
	printf("\nend\n");
	return 0;
}
