#ifndef MIE_GRAPHIC_H_
#define MIE_GRAPHIC_H_

/**
	@file mie_graphic.h
	@brief ȈWindow\W[

	@author $Author: mitsunari $
	@version $Revision: 1.1.1.1 $
	@date $Date: 2005/01/20 01:42:22 $
	@note open -> messageLoop̏ɌĂԂ
	Cxg[vrequestClosureĂԂmessageLoop𔲂
	}EXhbO͖Ή
*/

namespace MIE {

class Canvas {
public:
	enum {
		NOERR, //!< I
		ERR_INIT, //!< s
		ERR_WINDOW //!< EBhEɐĂȂ
	};
	enum EventType {
		NO_EVENT, //!< CxgȂ
		MOUSE_PRESS, //!< }EX
		MOUSE_RELEASE, //!< }EX
		KEY_PRESS, //!< L[
		TIMER, //!< ^C}[荞
		CREATE, //!< EBhEɈx
		DESTROY //!< EBhEŎɈx
	};

	enum Button {
		MOUSE_LEFT, //!< {^
		MOUSE_MIDDLE, //!< {^
		MOUSE_RIGHT //!< E{^
	};

	struct EventInfo { //!< Cxg\
		// MOUSECxĝƂ
		int mx; //!< }EX̍W
		int my; //!< }EX̍W
		Button sw; //!< }EX̃{^
		// L[CxĝƂ
		char key; //!< ̓L[(1̂)
		// ^C}[CxĝƂ
		void *timerData;
	};
	/** 
		Cxgnh
		EventHandler̕Ԃl0Ȃ瑱s 1ȂI
		}EXL[CxgȊÔƂinfoNULL肦
	*/
	typedef int (*EventHandler)(EventType type, const EventInfo *info, void *data);

	Canvas()
	{
		hdl_ = create();
	}

	~Canvas()
	{
		destroy(hdl_);
	}

	/**
		EBhE̐ƃCxgnh̓o^
		@param width [in] EBhẺ
		@param height [in] EBhȄc
		@param title [in] EBhẼ^Cg
		@param eventHandler [in] Cxgnh
		@param data [in] [Uf[^(openŎw肳ꂽf[^)
		@return G[ԍԂ

		@note eventHandler ̓Cxg閈ɌĂ΂R[obN֐
	*/

	int open(
		int width,
		int height,
		const char *title,
		EventHandler eventHandler,
		const void* data);

	/**
		bZ[W󂯂ăCxgnhɓn
		JԂ
		eventHandler0ȊO̒lԂ邢͊ȎŃEBhE
		j܂ŃubN

		ȈF
		CxgnhDESTROY𓊂

		requestClosureĂ΂ƏLIoăubN𔲂
	*/
	int messageLoop();

	/**
		EBhE悤ɖ߂𓊂
		@return G[ԍԂ
	*/
	int requestClosure();

	/**
		^C}[ݒ肷
		@param intervalMsec [in] 荞݊Ԋu(msec)
		@param timerData [in] ^C}[Cxgɓnf[^
		@param isOnce [in] x
	*/
	int startTimer(int intervalMsec, const void *timerData, bool isOnce = false);

	/**
		^C}[~߂
	*/
	int stopTimer();

	/**
		`̈ɑ΂čXVv𑗂
	*/
	int sendFlushMessage();

	/**
		zVRAM̃AhX擾
	*/
	char* getVramAddress() const;

	/**
		EBhE擾
	*/
	int getVramWidth() const;
	/**
		EBhEc擾
	*/
	int getVramHeight() const;
private:
	void *hdl_;
	static void *create();
	static void destroy(void *hdl);
};

} // end of namespace

#endif /* MIE_GRAPHIC_H_ */
