#ifndef RAWSOCKET_COMMON_H_
#define RAWSOCKET_COMMON_H_

#include <ctype.h>
/**
	@file rawsocket_common.h
	@brief raw\PbgeXgʃwb_
	@author $Author: shigeo $
	@version $Revision: 1.8 $
	@date $Date: 2007/03/05 07:52:32 $
*/

/**
	f[^_v
	@param buf [in] f[^
	@param bufSize [in] f[^TCY(byte)
*/
inline void dump(const void *buf, int bufSize)
{
	const unsigned char *p = reinterpret_cast<const unsigned char*>(buf);
	const int maxLine = 16;
	printf("size=%d\n", bufSize);
	if (bufSize <= 0) return;
	int remain = bufSize;
	for (int i = 0; i < maxLine; i++) {
		int disp = 16;
		if (remain < 16) {
			disp = remain;
		}
		for (int j = 0; j < 16; j++) {
			if (j < disp) {
				printf("%02X ", p[i * 16 + j]);
			} else {
				printf("-- ");
			}
		}
		for (int j = 0; j < disp; j++) {
			char c = p[i * 16 + j];
			putchar(isprint(c) ? c : '.');
		}
		putchar('\n');
		remain -= disp;
		if (remain <= 0) {
			break;
		}
	}
}

#endif /* RAWSOCKET_COMMON_H_ */
