/*!
	^CJvZÍc[
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mie_timecapsule.h"
#include "../server/ts_server.h"
#include "../encoder/ts_encoder.h"
#include "../decoder/ts_decoder.h"

int main(int argc, char *argv[])
{
	MIE_TC::init();

	argc--, argv++;
	if (argc == 0) {
		puts("usage");
		puts("tool [-s|e|d] [options]");
		return 1;
	}
	if (strcmp(*argv, "-s") == 0) {
		argc--, argv++;
		MIE_TC::TSserver system;
		return system.run(argc, argv);
	} else
	if (strcmp(*argv, "-e") == 0) {
		argc--, argv++;
		MIE_TC::TSencoder encoder;
		return encoder.run(argc, argv);
	} else
	if (strcmp(*argv, "-d") == 0) {
		argc--, argv++;
		MIE_TC::TSdecoder decoder;
		return decoder.run(argc, argv);
	}
	return 0;
}
