#ifndef   MTT_ARITHMETICS_TMPL_H
#define   MTT_ARITHMETICS_TMPL_H

// ===========================================================================
//  arithmetics_tmpl.h -- X̌vZ
// ---------------------------------------------------------------------------
// gp̐
//  ׂpairinǧvZAȉ~Ȑ̓_̐ȂǂsȂɂ͂̃t@C
// types_tmpl.ȟ #include B


#include "elliptic_power_tmpl.h"
#include "field_fq_power_tmpl.h"
#include "elliptic_genpoint_tmpl.h"
#include "pairing_tmpl.h"

template<class Mp, class Mm>
struct MttPairing {
	typedef typename Mtt<Mp>::Fp Fp;
	typedef typename Mtt<Mp>::Fq Fq;
	typedef typename Mtt<Mm>::Fm Fm;
	typedef typename Mtt<Mp>::EPoint EPoint;
	typedef typename MttPower<Mp, Mm>::Fq FqPower;
	typedef typename MttPower<Mp, Mm>::ECurve ECurve;
	
	/*!
		MttPower<ModP, ModM>::ECurve E;
		E.distort(Q, Q);
		ĂtateFast(E, F, P, Q, e);邱ƁD
		ttateFast(E, F, Q, P, e);ƂƒlςĂ܂
	*/
	static void tateFast(
		ECurve& E, FqPower& F, EPoint const& P, EPoint const& Q, Fq& e) {
		mttpair::tateFast<Fq, Fm>(E, F, P, Q, e);
	}
};

#endif /* MTT_ARITHMETICS_TMPL_H */

