#ifndef   MTT_FIELD_FQ_TMPL_H
#define   MTT_FIELD_FQ_TMPL_H

// ===========================================================================
//  field_fq_tmpl.h -- 2F_q = F_p(-1) ̃ev[gɂ
// ---------------------------------------------------------------------------
// wI
//  pfƂAF_p𐮐pŊ]̏WƂB̂ƂF_p̒ł
// 揜̉ZRɂ邱ƂoBF_pL(f)ƌB
// ܂Ap%4==3𖞂ƂƁA x*x%p == p-1 ƂȂ鐮x݂͑Ȃ̂ŁA
// F_pł̕ x^2 = -1 ̍F_p̒ɂ݂͑ȂBx^2 = -1̍-1
// ƂɂȀWɁ-1ĎlZo悤ɂƕf
// ̂Ɠv̂ŁAF_pɁ-1ĎlZo悤ɂ̂
// F_p(-1)ƂȂBL̂łAvf̐ p*p = q̂F_qƏB
// 2̂ƌĂ΂B
// 
// gp̐
//  Tmodulo pł̑{Z\ȃNXłƂAT͈ȉI/F
// Ƃ(e͏dw肵Ăǂ̂Ƃ)F
//   1. eRXgN^
//     T(), T(int), T(T const&)
//   2. eATC֐
//     static void set(int, T&), static void set(T const&, T&)
//   3. ePZ֐
//     static void {neg|inv}(T const&, T&)
//   4. e2Z֐
//     static void {add|sub|mul}(int, T&), 
//     static void {add|sub|mul}(Tconst&, T&)
//   5. e3Z֐
//     static void {add|sub|mul}(int, T const&, T&),
//     static void {add|sub|mul}(T const&, int, T&),
//     static void {add|sub|mul}(T const&, T const&, T&)
//   6. ̑
//     void normalize(), bool isZero()
//
// ̂ƂAe_<T, T> ړIƂ2F_q\NXƂȂBÂ܂
// ̃NXpł͂ȂB
// 
// ̐
//  ̎łtemplategAua = b + cv̂悤ȋLq add(b, c, a)
// 悤Ȋ֐ďoɕύXeNjbNgpĂBׂĂ̎ 
//   e_<base_type, expression> 
// Ƃ^ɂȂA͌^̕ϊɕ]A֐ďoɂȂB
//   e = (a+b)*(c-d);
// ƂɂƂĐB(a+b)*(c-d) Ƃł͌vZ͍sȂ
// Ƃ͂ȂA
//    e_<b_<e_<T, T>, binary_plus_<T>, e_<T, T> >,
//    binary_star_<T>,
//    b_<e_<T, T>, binary_minus_<T>, e_<T, T> > >
// Ƃ^̕ϐ a, b, c, d ̎QƂۑBۂ̕]͕ϐeւ̑
// ̍ۂɍsȂA܂֐e_<>.ev_()Ă΂A̒ binary_star_<>.ev_()
// Ă΂A̒Ŋ֐e_<>.ev_()Abinary_{plus|minus}_<>.ev_()Ă΂
// ƂɂȂ邪Ǎďoߒ̓RpCɂinlineWJB


namespace mttfq {
// ===========================================================================
//  "const&" comes after T iff T is e<> when one write "rr<T>::t_"
template<class T, class E> class e_;
template<class T> struct rr { typedef T t_; };
template<class T, class E> struct rr<e_<T, E> > { typedef e_<T, E>const& t_; };


// ===========================================================================
//  binary expressions
template<class LT, class Op, class RT>
struct b_ {
	typename rr<LT>::t_ vl_;
	typename rr<RT>::t_ vr_;
	b_(LT const& vl, RT const& vr) : vl_(vl), vr_(vr) {}
private:
	b_(); // to prevent a compiler calling the default constructor
};


// ===========================================================================
//  unary expressions
template<class Op, class T>
struct u_ {
	typename rr<T>::t_ v_;
	u_(T const& v) : v_(v) {}
private:
	u_(); // to prevent a compiler calling the default constructor
};


// ===========================================================================
//  type reduction : evaluates expression
template <class T, class E>
inline void se_(e_<T, E>const& ex, e_<T, T>& d) { ex.ev_(d); }


// ===========================================================================
//  the body of the class
template<class T>
class e_<T, T> {
public:
	// ----------------------------------------------------------------------
	//  type
	typedef T value_type;
	
	// ----------------------------------------------------------------------
	//  flags_
	enum {
		REAL_IS_ZERO = 1 << 0,
		IMAG_IS_ZERO = 1 << 8,
		IS_ZERO = REAL_IS_ZERO+IMAG_IS_ZERO,
		ENUM_FORBIDS_EXTRA_COMMAS
	};
	
	// ----------------------------------------------------------------------
	//  ctor, dtor
	e_() : flags_(IS_ZERO) {}
	explicit e_(int r) : flags_(IMAG_IS_ZERO)
		{ if(r) T::set(r, r_); else flags_ = IS_ZERO; }
	explicit e_(T const& r) : flags_(IMAG_IS_ZERO), r_(r) {}
	e_(e_ const& fq) :flags_(fq.flags_) {
		if(!(flags_&REAL_IS_ZERO)) T::set(fq.r_, r_);
		if(!(flags_&IMAG_IS_ZERO)) T::set(fq.i_, i_);
	}
	template<class E>
	e_(e_<T, E>const& fq) { se_(fq, *this); }

	e_(int r, int i) : flags_(0), i_(i)
		{ if(r) T::set(r, r_); else flags_ = REAL_IS_ZERO; }
	e_(int r, T const& i) : flags_(0), i_(i)
		{ if(r) T::set(r,  r_); else flags_ = REAL_IS_ZERO; }
	e_(T const& r, int i) : flags_(0), r_(r), i_(i) {}
	e_(T const& r, T const& i) : flags_(0), r_(r), i_(i) {}
	~e_() {}
	
	// ----------------------------------------------------------------------
	//  accessors
	T& getR() { return r_; }
	T const& getR() const { return r_; }
	T& getI() { return i_; }
	T const& getI() const { return i_; }
	int& getFlags() { return flags_; }
	int getFlags() const { return flags_; }
	bool isZero() const { return flags_ == IS_ZERO; }
	
	// ----------------------------------------------------------------------
	//  operations
	void inverse() {
		if(flags_&IMAG_IS_ZERO) {
			if(!(flags_&REAL_IS_ZERO)) T::inv(r_, r_);
			return;
		}
		if(flags_&REAL_IS_ZERO) {
			T::inv(i_, i_);
			T::neg(i_, i_);
			return;
		}
		// return (r - i sqrt(-1))/(r^2 + i^2)
		T tmp1(r_), tmp2(i_);
		T::mul(tmp1, tmp1);
		T::mul(tmp2, tmp2);
		T::add(tmp1, tmp2);
		T::inv(tmp2, tmp1);
		T::mul(tmp1, r_);
		T::mul(tmp1, i_);
		T::neg(i_, i_);
		return;
	}
	void normalize() const {
		if(!(flags_&REAL_IS_ZERO)) {
			r_.normalize();
			if(r_.isZero()) flags_ |= REAL_IS_ZERO;
		}
		if(!(flags_&IMAG_IS_ZERO)) {
			i_.normalize();
			if(i_.isZero()) flags_ |= IMAG_IS_ZERO;
		}
	}
	void negate() {
		if(!(flags_&REAL_IS_ZERO)) T::neg(r_, r_);
		if(!(flags_&IMAG_IS_ZERO)) T::neg(i_, i_);
	}
	void frobenius() {
		if(!(flags_&IMAG_IS_ZERO)) T::neg(i_, i_);
	}
	
	// ----------------------------------------------------------------------
	//  operator=
	e_ const& operator=(int r) {
		if(r) {
			T::set(r, r_);
			flags_ = IMAG_IS_ZERO;
		} else flags_ = IS_ZERO;
		return *this;
	}
	e_ const& operator=(T const& r) {
		T::set(r, r_);
		flags_ = IMAG_IS_ZERO;
		return *this;
	}
	e_ const& operator=(e_ const& fq) {
		flags_ = fq.flags_;
		if(!(flags_&REAL_IS_ZERO)) T::set(fq.r_, r_);
		if(!(flags_&IMAG_IS_ZERO)) T::set(fq.i_, i_);
		return *this;
	}
	template<class E>
	e_ const& operator=(e_<T, E>const& fq) { se_(fq, *this); return *this; }
	
	// ----------------------------------------------------------------------
	//  operator+=
	e_ const& operator+=(int r) {
		if(!r) return *this;
		if(flags_&REAL_IS_ZERO) {
			flags_ -= REAL_IS_ZERO;
			T::set(r, r_);
		} else T::add(r, r_);
		return *this;
	}
	e_ const& operator+=(T const& r) {
		if(flags_&REAL_IS_ZERO) {
			flags_ -= REAL_IS_ZERO;
			T::set(r, r_);
		} else T::add(r, r_);
		return *this;
	}
	e_ const& operator+=(e_ const& fq) {
		if(!(fq.flags_&REAL_IS_ZERO)) {
			if(flags_&REAL_IS_ZERO) {
				flags_ -= REAL_IS_ZERO;
				T::set(fq.r_, r_);
			} else T::add(fq.r_, r_);
		}
		if(fq.flags_&IMAG_IS_ZERO) return *this;
		if(flags_&IMAG_IS_ZERO) {
			flags_ -= IMAG_IS_ZERO;
			T::set(fq.i_, i_);
		} else T::add(fq.i_, i_);
		return *this;
	}
	template<class E> // with type reduction
	e_ const& operator+=(e_<T, E>const& fq) {
		e_<T, T> tmp(fq);
		return *this += tmp;
	}
	
	// ----------------------------------------------------------------------
	//  operator-=
	e_ const& operator-=(int r) {
		if(!r) return *this;
		if(flags_&REAL_IS_ZERO) {
			flags_ -= REAL_IS_ZERO;
			T::set(-r, r_);
		} else T::add(-r, r_);
		return *this;
	}
	e_ const& operator-=(T const& r) {
		if(flags_&REAL_IS_ZERO) {
			flags_ -= REAL_IS_ZERO;
			T::neg(r, r_);
		} else T::sub(r, r_);
		return *this;
	}
	e_ const& operator-=(e_ const& fq) {
		if(!(fq.flags_&REAL_IS_ZERO)) {
			if(flags_&REAL_IS_ZERO) {
				flags_ -= REAL_IS_ZERO;
				T::neg(fq.r_, r_);
			} else T::sub(fq.r_, r_);
		}
		if(fq.flags_&IMAG_IS_ZERO) return *this;
		if(flags_&IMAG_IS_ZERO) {
			flags_ -= IMAG_IS_ZERO;
			T::neg(fq.i_, i_);
		} else T::sub(fq.i_, i_);
		return *this;
	}
	template<class E> // with type reduction
	e_ const& operator-=(e_<T, E>const& fq) {
		e_<T, T> tmp(fq);
		return *this -= tmp;
	}
	
	// -------------------------------------
	//  operator*=
	e_ const& operator*=(int r) {
		if(!r) {
			flags_ = IS_ZERO;
			return *this;
		}
		if(!(flags_&REAL_IS_ZERO)) T::mul(r, r_);
		if(!(flags_&IMAG_IS_ZERO)) T::mul(r, i_);
		return *this;
	}
	e_ const& operator*=(T const& r) {
		if(!(flags_&REAL_IS_ZERO)) T::mul(r, r_);
		if(!(flags_&IMAG_IS_ZERO)) T::mul(r, i_);
		return *this;
	}
	e_ const& operator*=(e_ const& fq) {
		if(flags_ == IS_ZERO) return *this;
		if(fq.flags_ == IS_ZERO) {
			flags_ = IS_ZERO;
			return *this;
		}
		if(!(flags_|fq.flags_)) {
			if(this == &fq) {
				T tmp1(r_), tmp2(r_);
				T::add(i_, tmp1);
				T::sub(i_, tmp2);
				T::add(i_, i_);
				T::mul(r_, i_);
				T::mul(tmp1, tmp2, r_);
			} else {
				T tmp1(r_), tmp2(fq.r_);
				T::sub(i_, tmp1);
				T::sub(fq.i_, tmp2);
				T::mul(tmp2, tmp1);
				T::mul(fq.r_, r_);
				T::mul(fq.i_, i_);
				T::sub(r_, tmp1);
				T::sub(tmp1, i_);
				T::sub(tmp1, r_);
				T::sub(i_, r_);
			}
			return *this;
		}
		if(!((flags_|fq.flags_)&IMAG_IS_ZERO)) { // i_, fq.i_ not zero
			if(!flags_) {
				T tmp(r_);
				T::mul(i_, fq.i_, r_);
				T::neg(r_, r_); 
				T::mul(tmp, fq.i_, i_);
				return *this;
			}
			T::mul(i_, fq.i_, r_);
			T::neg(r_, r_); 
		}
		if(!((flags_&REAL_IS_ZERO)||(fq.flags_&IMAG_IS_ZERO))) {
			T::mul(r_, fq.i_, i_); // r_, fq.i_ not zero
		}
		if(!((flags_&IMAG_IS_ZERO)||(fq.flags_&REAL_IS_ZERO))) {
			T::mul(fq.r_, i_); // i_, fq.r_ not zero
		}
		// r_, fq.r_ not zero
		if(!((flags_|fq.flags_)&REAL_IS_ZERO)) T::mul(fq.r_, r_);
		if(!(fq.flags_&IMAG_IS_ZERO)) { // flags change
			if(!fq.flags_) flags_ = 0;
			else if(flags_) flags_ ^= IS_ZERO;
		}
		return *this;
	}
	template<class E> // with type reduction
	e_ const& operator*=(e_<T, E>const& fq) {
		e_<T, T> tmp(fq);
		return *this *= tmp;
	}

protected:
	mutable int flags_;
	mutable T r_, i_;
};


// ===========================================================================
//  expression classes
// -----------------------------------
// expressions like "a+a"
template<class T, class Op>
class e_<T, b_<e_<T, T>, Op, e_<T, T> > > {
	b_<e_<T, T>, Op, e_<T,T> > ex_;
public:
	e_(e_<T, T>const& vl, e_<T, T>const& vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const { Op::ev_(ex_.vl_, ex_.vr_, d); }
};
// -----------------------------------
// expressions like "a+1"
template<class T, class Op>
class e_<T, b_<e_<T, T>, Op, int> >{
	b_<e_<T, T>, Op, int> ex_;
public:
	e_(e_<T, T>const& vl, int vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const { Op::ev_(ex_.vl_, ex_.vr_, d); }
};
// -----------------------------------
// expressions like "1+a"
template<class T, class Op>
class e_<T, b_<int, Op, e_<T, T> > >{
	b_<int, Op, e_<T, T> > ex_;
public:
	e_(int vl, e_<T, T>const& vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const { Op::ev_(ex_.vl_, ex_.vr_, d); }
};
// -----------------------------------
// expressions like "a*(b+c)"
template<class T, class Op, class E>
class e_<T, b_<e_<T, T>, Op, e_<T, E> > >{
	b_<e_<T, T>, Op, e_<T, E> > ex_;
public:
	e_(e_<T, T>const& vl, e_<T, E>const& vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const {
		d = ex_.vr_;
		Op::ev_(ex_.vl_, d, d);
	}
};
// -----------------------------------
// expressions like "a*b+c"
template<class T, class E, class Op>
class e_<T, b_<e_<T, E>, Op, e_<T, T> > >{
	b_<e_<T, E>, Op, e_<T, T> > ex_;
public:
	e_(e_<T, E>const& vl, e_<T, T>const& vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const {
#if 1
		e_<T, T> tmp(ex_.vl_);
		Op::ev_(tmp, ex_.vr_, d);
#else /* QQQ:܂Ȃ(ǂ|ẐƂɃ~X̂) */
		d = ex_.vl_;
		Op::ev_(ex_.vr_, d);
#endif
	}
};
// -----------------------------------
// expressions like "3*(a+b)"
template<class T, class Op, class E>
class e_<T, b_<int, Op, e_<T, E> > >{
	b_<int, Op, e_<T, E> > ex_;
public:
	e_(int vl, e_<T, E>const& vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const {
		d = ex_.vr_;
		Op::ev_(ex_.vl_, d, d);
	}
};
// -----------------------------------
// expressions like "(a+3)*b"
template<class T, class E, class Op>
class e_<T, b_<e_<T, E>, Op, int> >{
	b_<e_<T, E>, Op, int> ex_;
public:
	e_(e_<T, E>const& vl, int vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const {
		d = ex_.vl_;
		Op::ev_(d, ex_.vr_, d);
	}
};
// -----------------------------------
// expressions like "(a+3)*(b+c)"
template<class T, class E1, class Op, class E2>
class e_<T, b_<e_<T, E1>, Op, e_<T, E2> > >{
	b_<e_<T, E1>, Op, e_<T, E2> > ex_;
public:
	e_(e_<T, E1>const& vl, e_<T, E2>const& vr) : ex_(vl, vr) {}
	void ev_(e_<T, T>& d) const {
		e_<T, T> tmpl(ex_.vl_);
		d = ex_.vr_;
		Op::ev_(tmpl, d, d);
	}
};
// -----------------------------------
// expressions like "-a"
template<class T, class Op>
class e_<T, u_<Op, e_<T, T> > > {
	u_<Op, e_<T, T> > ex_;
public:
	e_(e_<T, T>const& v) : ex_(v) {}
	void ev_(e_<T, T>& d) const { Op::ev_(ex_.v_, d); }
};
// -----------------------------------
// expressions like "-(a+a)"
template<class T, class Op, class E>
class e_<T, u_<Op, e_<T, E> > > {
	u_<Op, e_<T, E> > ex_;
public:
	e_(e_<T, E>const& v) : ex_(v) {}
	void ev_(e_<T, T>& d) const {
		d = ex_.v_;
		Op::ev_(d, d);
	}
};


// ===========================================================================
//  macros for operators
#define RealIsZero(x) (x.getFlags()&e_<T,T>::REAL_IS_ZERO)
#define ImagIsZero(x) (x.getFlags()&e_<T,T>::IMAG_IS_ZERO)
#define IsZero(x) (x.getFlags() == e_<T,T>::IS_ZERO)

// ===========================================================================
//  operator+
template<class T>
struct binary_plus_ {
	static void ev_(e_<T, T>const& lt, e_<T, T>const& rt, e_<T, T>& d) {
		int f = 0;
		if(RealIsZero(lt)) {
			if(RealIsZero(rt)) f = e_<T, T>::REAL_IS_ZERO;
			else T::set(rt.getR(), d.getR());
		} else {
			if(RealIsZero(rt)) T::set(lt.getR(), d.getR());
			else T::add(lt.getR(), rt.getR(), d.getR());
		}
		if(ImagIsZero(lt)) {
			if(ImagIsZero(rt)) f |= e_<T, T>::IMAG_IS_ZERO;
			else T::set(rt.getI(), d.getI());
		} else {
			if(ImagIsZero(rt)) T::set(lt.getI(), d.getI());
			else T::add(lt.getI(), rt.getI(), d.getI());
		}
		d.getFlags() = f;
	}
	static void ev_(e_<T, T>const& lt, int rt, e_<T, T>& d) {
		if(!rt) {
			d.getFlags() = lt.getFlags();
			if(!RealIsZero(d)) T::set(lt.getR(), d.getR());
			if(!ImagIsZero(d)) T::set(lt.getI(), d.getI());
			return;
		}
		d.getFlags() = ImagIsZero(lt);
		if(RealIsZero(lt)) T::set(rt, d.getR());
		else T::add(lt.getR(), rt, d.getR());
		if(!d.getFlags()) T::set(lt.getI(), d.getI());
	}
	static void ev_(int lt, e_<T, T>const& rt, e_<T, T>& d) {
	  ev_(rt, lt, d);
	}
	static void ev_(e_<T, T>const& rt, e_<T, T>& d) {
	  d += rt;
	}
};
template<class T, class LT, class RT>
inline e_<T, b_<e_<T, LT>, binary_plus_<T>, e_<T, RT> > >
operator+(e_<T, LT>const& lt, e_<T, RT>const& rt) {
	return e_<T, b_<e_<T, LT>, binary_plus_<T>, e_<T, RT> > >(lt, rt);
}
template<class T, class RT>
inline e_<T, b_<int, binary_plus_<T>, e_<T, RT> > >
operator+(int lt, e_<T, RT>const& rt) {
	return e_<T, b_<int, binary_plus_<T>, e_<T, RT> > >(lt, rt);
}
template<class T, class LT>
inline e_<T, b_<e_<T, LT>, binary_plus_<T>, int> >
operator+(e_<T, LT>const& lt, int rt) {
	return e_<T, b_<e_<T, LT>, binary_plus_<T>, int> >(lt, rt);
}


// ===========================================================================
//  operator-
template<class T>
struct binary_minus_ {
	static void ev_(e_<T, T>const& lt, e_<T, T>const& rt, e_<T, T>& d) {
		int f = 0;
		if(RealIsZero(lt)) {
			if(RealIsZero(rt)) f = e_<T, T>::REAL_IS_ZERO;
			else T::neg(rt.getR(), d.getR());
		} else {
			if(RealIsZero(rt)) T::set(lt.getR(), d.getR());
			else T::sub(lt.getR(), rt.getR(), d.getR());
		}
		if(ImagIsZero(lt)) {
			if(ImagIsZero(rt)) f |= e_<T, T>::IMAG_IS_ZERO;
			else T::neg(rt.getI(), d.getI());
		} else {
			if(ImagIsZero(rt)) T::set(lt.getI(), d.getI());
			else T::sub(lt.getI(), rt.getI(), d.getI());
		}
		d.getFlags() = f;
	}
	static void ev_(e_<T, T>const& lt, int rt, e_<T, T>& d) {
		if(!rt) {
			d.getFlags() = lt.getFlags();
			if(!RealIsZero(d)) T::set(lt.getR(), d.getR());
			if(!ImagIsZero(d)) T::set(lt.getI(), d.getI());
			return;
		}
		d.getFlags() = ImagIsZero(lt);
		if(RealIsZero(lt)) T::set(-rt, d.getR());
		else T::sub(lt.getR(), rt, d.getR());
		if(!d.getFlags()) T::set(lt.getI(), d.getI());
	}
	static void ev_(int lt, e_<T, T>const& rt, e_<T, T>& d) {
		if(!lt) {
			d.getFlags() = rt.getFlags();
			if(!RealIsZero(d)) T::neg(rt.getR(), d.getR());
			if(!ImagIsZero(d)) T::neg(rt.getI(), d.getI());
			return;
		}
		d.getFlags() = ImagIsZero(rt);
		if(RealIsZero(rt)) T::set(lt, d.getR());
		else T::sub(lt, rt.getR(), d.getR());
		if(!d.getFlags()) T::neg(rt.getI(), d.getI());
	}
	static void ev_(e_<T, T>const& rt, e_<T, T>& d) {
	  d -= rt;
	}
};
template<class T, class LT, class RT>
inline e_<T, b_<e_<T, LT>, binary_minus_<T>, e_<T, RT> > >
operator-(e_<T, LT>const& lt, e_<T, RT>const& rt) {
	return e_<T, b_<e_<T, LT>, binary_minus_<T>, e_<T, RT> > >(lt, rt);
}
template<class T, class RT>
inline e_<T, b_<int, binary_minus_<T>, e_<T, RT> > >
operator-(int lt, e_<T, RT>const& rt) {
	return e_<T, b_<int, binary_minus_<T>, e_<T, RT> > >(lt, rt);
}
template<class T, class LT>
inline e_<T, b_<e_<T, LT>, binary_minus_<T>, int> >
operator-(e_<T, LT>const& lt, int rt) {
	return e_<T, b_<e_<T, LT>, binary_minus_<T>, int> >(lt, rt);
}


// ===========================================================================
//  operator*
template<class T>
struct binary_star_ {
	static void ev_(e_<T, T>const& lt, e_<T, T>const& rt, e_<T, T>& d) {
		if(&lt == &d) {
			d *= rt;
			return;
		}
		if(&rt == &d) {
			d *= lt;
			return;
		}
		if(IsZero(lt)||IsZero(rt)) {
			d.getFlags() = e_<T, T>::IS_ZERO;
			return;
		}
		if(&lt == &rt) {
			if(RealIsZero(lt)) {
				T::mul(lt.getI(), lt.getI(), d.getI());
				T::neg(d.getI(), d.getR());
			} else if(ImagIsZero(lt)) {
				T::mul(lt.getR(), lt.getR(), d.getR());
			} else {
				T::add(lt.getR(), lt.getI(), d.getR());
				T::sub(lt.getR(), lt.getI(), d.getI());
				T::mul(d.getI(), d.getR());
				T::add(lt.getR(), lt.getR(), d.getI());
				T::mul(lt.getI(), d.getI());
			}
			if(lt.getFlags()) d.getFlags() = e_<T, T>::IMAG_IS_ZERO;
			else d.getFlags() = 0;
			return;
		}
		if(!(lt.getFlags()|rt.getFlags())) {
			T tmp;
			T::sub(lt.getR(), lt.getI(), d.getR());
			T::sub(rt.getR(), rt.getI(), d.getI());
			T::mul(d.getR(), d.getI(), tmp);
			T::mul(lt.getR(), rt.getR(), d.getR());
			T::mul(lt.getI(), rt.getI(), d.getI());
			T::sub(d.getR(), tmp);
			T::sub(d.getI(), d.getR());
			T::sub(tmp, d.getI());
			d.getFlags() = 0;
			return;
		}
		if(!((lt.getFlags()|rt.getFlags())&e_<T, T>::IMAG_IS_ZERO)) {
			T::mul(lt.getI(), rt.getI(), d.getR());
			T::neg(d.getR(), d.getR()); 
		}
		if(!(RealIsZero(lt)||ImagIsZero(rt))) {
			T::mul(lt.getR(), rt.getI(), d.getI());
		}
		if(!(ImagIsZero(lt)||RealIsZero(rt))) {
			T::mul(rt.getR(), lt.getI(), d.getI());
		}
		if(!((lt.getFlags()|rt.getFlags())&e_<T, T>::REAL_IS_ZERO)) {
			T::mul(lt.getR(), rt.getR(), d.getR());
		}
		int f = rt.getFlags();
		if(!ImagIsZero(lt)) {
			if(!lt.getFlags()) f = 0;
			else if(rt.getFlags()) f ^= e_<T, T>::IS_ZERO;
		}
		d.getFlags() = f;
	}
	static void ev_(e_<T, T>const& lt, int rt, e_<T, T>& d) {
		if(!rt) {
			d.getFlags() = e_<T, T>::IS_ZERO;
			return;
		}
		d.getFlags() = lt.getFlags();
		if(&lt == &d) {
			if(!RealIsZero(d)) T::mul(rt, d.getR());
			if(!ImagIsZero(d)) T::mul(rt, d.getI());
			return;
		}
		if(!RealIsZero(lt)) T::mul(lt.getR(), rt, d.getR());
		if(!RealIsZero(lt)) T::mul(lt.getI(), rt, d.getI());
	}
	static void ev_(int lt, e_<T, T>const& rt, e_<T, T>& d) {
		ev_(rt, lt, d);
	}
	static void ev_(e_<T, T>const& rt, e_<T, T>& d) {
	  d *= rt;
	}
};
template<class T, class LT, class RT>
inline e_<T, b_<e_<T, LT>, binary_star_<T>, e_<T, RT> > >
operator*(e_<T, LT>const& lt, e_<T, RT>const& rt) {
	return e_<T, b_<e_<T, LT>, binary_star_<T>, e_<T, RT> > >(lt, rt);
}
template<class T, class RT>
inline e_<T, b_<int, binary_star_<T>, e_<T, RT> > >
operator*(int lt, e_<T, RT>const& rt) {
	return e_<T, b_<int, binary_star_<T>, e_<T, RT> > >(lt, rt);
}
template<class T, class LT>
inline e_<T, b_<e_<T, LT>, binary_star_<T>, int> >
operator*(e_<T, LT>const& lt, int rt) {
	return e_<T, b_<e_<T, LT>, binary_star_<T>, int> >(lt, rt);
}


// ===========================================================================
//  operator-
template<class T>
struct unary_minus_ {
	static void ev_(e_<T, T>const& t, e_<T, T>& d) {
		d.getFlags() = t.getFlags();
		if(!RealIsZero(d)) T::neg(t.getR(), d.getR());
		if(!ImagIsZero(d)) T::neg(t.getI(), d.getI());
	}
};
template<class T, class E>
inline e_<T, u_<unary_minus_<T>, e_<T, E> > >
operator-(e_<T, E>const& v) {
	return e_<T, u_<unary_minus_<T>, e_<T, E> > >(v);
}


// ===========================================================================
//  function frobenius
template<class T>
struct unary_frobenius_ {
	static void ev_(e_<T, T>const& t, e_<T, T>& d) {
		d.getFlags() = t.getFlags();
		if(!RealIsZero(d)) T::set(t.getR(), d.getR());
		if(!ImagIsZero(d)) T::neg(t.getI(), d.getI());
	}
};
template<class T, class E>
inline e_<T, u_<unary_frobenius_<T>, e_<T, E> > >
frobenius(e_<T, E>const& v) {
	return e_<T, u_<unary_frobenius_<T>, e_<T, E> > >(v);
}

// ===========================================================================
//  function inverse
template<class T>
struct unary_inverse_ {
	static void ev_(e_<T, T>const& t, e_<T, T>& d) {
		d.getFlags() = t.getFlags();
		if(ImagIsZero(d)) {
			if(!RealIsZero(d)) T::inv(t.getR(), d.getR());
			return;
		}
		if(RealIsZero(d)) {
			T::inv(t.getI(), d.getI());
			T::neg(d.getI(), d.getI());
			return;
		}
		// return (r - i sqrt(-1))/(r^2 + i^2)
		d.getFlags() = 0;
		if(&t == &d) {
			T tmp1(t.getR()), tmp2(t.getI());
			T::mul(tmp1, tmp1);
			T::mul(tmp2, tmp2);
			T::add(tmp1, tmp2);
			T::inv(tmp2, tmp1);
			T::mul(tmp1, d.getR());
			T::mul(tmp1, d.getI());
			T::neg(d.getI(), d.getI());
		} else {
			T::mul(t.getR(), t.getR(), d.getR());
			T::mul(t.getI(), t.getI(), d.getI());
			T::add(d.getR(), d.getI());
			T::inv(d.getI(), d.getR());
			T::mul(t.getI(), d.getR(), d.getI());
			T::mul(t.getR(), d.getR());
			T::neg(d.getI(), d.getI());
		}
	}
};
template<class T, class E>
inline e_<T, u_<unary_inverse_<T>, e_<T, E> > >
inverse(e_<T, E>const& v) {
	return e_<T, u_<unary_inverse_<T>, e_<T, E> > >(v);
}


// ===========================================================================
//  end of macros for operators
#undef RealIsZero
#undef ImagIsZero
#undef IsZero

// ===========================================================================
//  end of namespace
}


#endif /* MTT_FIELD_FQ_TMPL_H */
